/****************************************************
 *                                                   
 *    File Name : mult.c                             
 *                                                   
 *    Author    : KIM, DONGMIN (kimd@top.cis.syr.edu)
 *                                                   
 ****************************************************/
#include <stdio.h>
#include <malloc.h>
#include <sys/types.h>
#include <unistd.h>
#include <math.h>
#include <string.h>

main(argc,argv)
     int  argc;
     char *argv[];
{
  int nsize;
  int inch1, inch2, outch1;
  char tmp[10];
  char *temp;
  int i, j, k;
  int vector_size;
  int matrix_size;
  float **Matrix, **submatrix;
  float *result;
  float *Vector;
  float element, zero;

  long  total_elapsed;
  FILE  *fd, *fd1;
  char  *task_name;
  int   task_id;
  char  file_name[100];
  char	*out1_msg;
  char  *io_file;
  int   *counter;
  char  *buf2;
  int   *tmp_matrix_size;
  int   total_size;
  char  *send_buf;
  float *tmp_float;

  char input_file_1[30];
  char input_file_2[30];
  char output_X[30];

  strcpy(input_file_1, argv[1]);
  strcpy(input_file_2, argv[2]);
  strcpy(output_X, argv[3]);

  /* external file */
  /* get input data from file */
  fd1 = fopen(input_file_1, "r");
 
  if ( fd1 == NULL ) {
    printf("\ncannot find file!\n");
    exit(1);
  }
 
  /* read the size of the matrix. */
  fscanf( fd1, "%d", &matrix_size );

  Matrix =  (float **) malloc(matrix_size * sizeof(float *));
  if (Matrix == NULL) {
    printf("malloc error at Matrix");
  }
  for ( i = 0 ; i < matrix_size ; i++ ) {
    Matrix[i] = (float *) malloc(matrix_size * sizeof(float));
    if (Matrix[i] == NULL) {
      printf("malloc error at Matrix[%d]", i);
    }
  }

  /* read from the file */
  for ( i = 0 ; i < matrix_size ; i++ ) {
    for ( j = 0 ; j < matrix_size ; j++ ) {
      fscanf(fd1, "%f", &element);
      Matrix[i][j] = element;
    }
  }
  fclose(fd1);

  /* external file */
  /* get input data from file */
  fd1 = fopen(input_file_2, "r");
 
  if ( fd1 == NULL ) {
    printf("\ncannot find file!\n");
    exit(1);
  }
 
  /* read the size of the matrix. */
  fscanf( fd1, "%d", &vector_size );

  Vector =  (float *) malloc(matrix_size * sizeof(float ));
  if (Vector == NULL) {
    printf("malloc error at Vector");
  }

  /* read from the file */
  for ( i = 0 ; i < vector_size ; i++ ) {
    fscanf(fd1, "%f", &element);
    Vector[i] = element;
  }
  fclose(fd1);

  result =  (float *) malloc(vector_size * sizeof(float ));
  if (result == NULL) {
	fprintf(fd, "malloc error at result");
  }

  sec_timer_reset();

  compute_mult(Matrix, Vector, result, matrix_size);


  total_elapsed = sec_timer_elapsed();

  printf("Matrix-Vector Multiplication - matrix size %d : %d\n", matrix_size, total_elapsed);

  /**
  // external file
  fd1 = fopen(output_X, "w");
 
  if ( fd1 == NULL ) {
    printf("\ncannot find file!\n");
  }
  else {
    fprintf(fd1, "%d\n", matrix_size);
    for ( i = 0 ; i < matrix_size ; i++ ) {
      fprintf( fd1, "%7.3f", result[i]);
    }
    fprintf(fd1, "\n");
    fclose(fd1);
  }
  **/
}

compute_mult(A, B, result, matrix_size)
float **A, *B, *result;
int   matrix_size;

{
  int    i, j;


  /* compute the allocated data */
  for ( i = 0 ; i < matrix_size ; i++ ) {
    result[i] = 0.;
    for ( j = 0 ; j < matrix_size ; j++ ) {
      result[i] = result[i] + A[i][j] * B[j];
    }
  }

/*
  printf("\n\n slave %d: result\n",my_id);
  for ( i = 0 ; i < load ; i++ ) {
    printf(" %5.2f ", result[i]);
  }
  printf("\n");
*/

}

